<?php
/*
* 2011 Judith Buetas Solanellas
*
* NOTICE OF LICENSE
*
* This source file is subject to the Academic Free License (AFL 3.0)
* that is bundled with this package in the file LICENSE.txt.
* It is also available through the world-wide-web at this URL:
* http://opensource.org/licenses/afl-3.0.php
* If you did not receive a copy of the license and are unable to
* obtain it through the world-wide-web, please send an email
* to license@prestashop.com so we can send you a copy immediately.
*
* DISCLAIMER
*
* Do not edit or add to this file if you wish to upgrade PrestaShop to newer
* versions in the future.
*
*  @author Judith Buetas Solanellas <jbuetass@uoc.edu>
*  @copyright  2011 Judith Buetas Solanellas
*  @date 08/12/2011
*  @version  Release: $Revision: 1.0 $
*  @license    http://opensource.org/licenses/afl-3.0.php  Academic Free License (AFL 3.0)
*/

class abandonedShoppingCartsSql extends ObjectModel
{	
	protected 	$table = 'abandoned_shopping_carts_emails';
	protected 	$identifier = 'id_abandoned_shopping_cart';
		
	//Consultar compras inacabadas con pedido
	//Return array
	public function checkAbandonedPurchases()
	{
		global $cookie;
	
		$sql = "SELECT c.id_cart, c.id_customer, c.id_guest, c.secure_key, c.date_add,
		o.id_order, o.payment, osl.id_order_state, osl.id_lang, osl.name
		FROM `"._DB_PREFIX_."cart` AS c 
		LEFT OUTER JOIN `"._DB_PREFIX_.$this->table."` AS asce ON c.id_cart = asce.id_cart 
		LEFT OUTER JOIN `"._DB_PREFIX_."orders` AS o ON c.id_cart = o.id_cart 
		LEFT JOIN (select * from `"._DB_PREFIX_."order_history` order by id_order_history desc) AS oh ON o.id_order = oh.id_order		
		LEFT JOIN `"._DB_PREFIX_."order_state_lang` AS osl ON osl.id_order_state = oh.id_order_state
                WHERE 
                (asce.id_abandoned_shopping_cart IS null or asce.send=0) AND 
                c.date_add between '".$this->date." 00:00:00' AND '".$this->date." 23:59:59' AND
                o.valid=false AND osl.id_lang=".(int)($cookie->id_lang)."
		GROUP BY oh.id_order
		ORDER BY oh.id_order DESC ";

		return (Db::getInstance()->ExecuteS($sql));
	}
	
	//Consultar compras inacabadas incluidas las que ya se les ha enviado el email
	//Return array
	public function checkAbandonedPurchasesWithMails($start_paginator="", $num_items_paginator="")
	{
		global $cookie;
			
		$sql = "SELECT c.id_cart, c.id_customer, c.id_guest, c.secure_key, c.date_add,asce.send,
		IF(cu.id_customer, CONCAT(cu.`firstname`, ' ',  cu.`lastname`), 'Guest') customer_name,
		o.id_order, o.payment, osl.id_order_state, osl.id_lang, osl.name
		FROM `"._DB_PREFIX_."cart` AS c 
	 	LEFT JOIN `"._DB_PREFIX_.$this->table."` AS asce ON c.id_cart = asce.id_cart 
		LEFT OUTER JOIN `"._DB_PREFIX_."orders` AS o ON c.id_cart = o.id_cart 
		LEFT JOIN (select * from `"._DB_PREFIX_."order_history` order by id_order_history desc) AS oh ON o.id_order = oh.id_order		
		LEFT JOIN `"._DB_PREFIX_."order_state_lang` AS osl ON osl.id_order_state = oh.id_order_state
                LEFT JOIN `"._DB_PREFIX_."customer` cu ON (c.`id_customer` = cu.`id_customer`) 
                WHERE 
                o.valid=false AND osl.id_lang=".(int)($cookie->id_lang)."
		GROUP BY oh.id_order
		ORDER BY oh.id_order DESC ".
                ($num_items_paginator ? 'LIMIT '.(int)($start_paginator).', '.(int)($num_items_paginator) : ''); 

		return (Db::getInstance()->ExecuteS($sql));
	}
		
	//Add a row in addAbandonedShoppingCartsEmails
 	//return boolean succeed
 	public function addAbandonedShoppingCartsEmails()
	{
		if (!Validate::isUnsignedId($this->id))
			die(Tools::displayError());
		
		$sql = 'INSERT INTO `'._DB_PREFIX_.$this->table.'` 
				(`id_cart`, `send`) 
				VALUES 
				('.$this->id.','.$this->send.')';

		return (Db::getInstance()->Execute($sql));
	}
}
