<?php

/* +--------------------------------------------------------+
 * |														|
 * |	Group-discount module @2010 , version 1.1.0			|
 * |	rade.popovic@gmail.com								|
 * |	Modifications by Cesar Penafiel to work with PS 1.4	|
 * |	and to allow for price modification					|
 * |	2011-11-20 Fix to keep other special pricing        |
 * |	2011-11-29 Fix to make product pricing overwrite    |
 * |	category											|
 * |	All rights reserved									|
 * |														|
 * | 	No Warranty											|
 * |	Unless otherwise stated, the software on 			|
 * |	this module is provided "as-is," without any 		|
 * |	express or implied warranty. In no event I shall be |
 * |	held liable for any damages arising from the use of |
 * |	the software.										|
 * +--------------------------------------------------------+
 */

include_once(PS_ADMIN_DIR.'/../classes/AdminTab.php');



class Discount extends AdminTab
{

	private $groups = array();
	private $errors = array();
	private $defaultLanguage;

	public function __construct()
	{
		parent::__construct();
		$this->defaultLanguage = intval(Configuration::get('PS_LANG_DEFAULT'));
	}

	
	private static function _updateCategoryDiscount($category_id,$category_value) {
		$parent_category = $category_id;
		while($parent_category > -1) {
			$sql = "SELECT id_category FROM "._DB_PREFIX_."category WHERE id_parent=" . $parent_category;
			$categories = Db::getInstance()->ExecuteS($sql);
			$parent_category = -1;
			foreach($categories as $category) {
				$parent_category = $category['id_category'];
				if($parent_category > -1) {
					$type='"percentage"';
					$reduction=($category_value['discount'] != "" ? $category_value['discount']/100 : "0");
					$sql = "insert into "._DB_PREFIX_."specific_price (id_product,reduction,reduction_type,"._DB_PREFIX_."specific_price.from,"._DB_PREFIX_."specific_price.to,groupdiscount,from_quantity) (select "._DB_PREFIX_."product.id_product,"
					.$reduction.",".$type.", 
					".($category_value['fromDate']==""?'NULL':"'" . date("Y-m-d",strtotime($category_value['fromDate'])) . "'").",
					".($category_value['toDate']==""?'NULL':"'" . date("Y-m-d",strtotime($category_value['toDate'])) . "'") . " 
					,1,1 from "._DB_PREFIX_."product where id_product NOT IN (SELECT 
					 id_product from "._DB_PREFIX_."specific_price WHERE groupdiscount=1) AND id_category_default=".$parent_category.");";
					Db::getInstance()->Execute($sql);

					$sql = "UPDATE "._DB_PREFIX_."product SET  
								on_sale='" . ($category_value['displayOnSale'] == 1 ? "1":"0") ."' 
								WHERE id_category_default=" . $parent_category;
					Db::getInstance()->Execute($sql);

					Discount::_updateCategoryDiscount($parent_category,$category_value);
				}
			}
		}
	}
	
	public static function getGroupDiscountValue() {
		$sum = "";
		$counter = 0;
		do {
			$val = Configuration::get('GROUPDISCOUNT_GROUPS_'.$counter);
			$counter++;
			$sum .= $val;
		} while(strlen($val) >= 50000);
		return unserialize($sum);
	}
	
	private static function  setGroupDiscountValue($value) {
		$sum = serialize($value);
		$counter = 0;
		do {
			$val = substr($sum,0,50000);
			Configuration::updateValue('GROUPDISCOUNT_GROUPS_'.$counter,$val);
			$counter++;
			$sum = substr($sum,50000);
		} while(strlen($sum) > 0);
	}
	
	public static function updateDiscounts() {
		$groups = Discount::getGroupDiscountValue();
		
		$groupdiscountExist = count(Db::getInstance()->ExecuteS("SHOW COLUMNS FROM "._DB_PREFIX_."specific_price LIKE 'groupdiscount'"));
		
		$sql = "ALTER IGNORE TABLE "._DB_PREFIX_."specific_price ADD groupdiscount bit;"; //ADD groupdiscount bit
		if(!$groupdiscountExist) Db::getInstance()->Execute($sql);
		$sql = "DELETE FROM "._DB_PREFIX_."specific_price WHERE groupdiscount=1;";
		Db::getInstance()->Execute($sql);
		// categories
		if(is_array($groups['categories'])) {
			foreach($groups['categories'] as $key=>$value) {
				if($value['discount'] != "") {				
					$type='"percentage"';
					$reduction=($value['discount'] != "" ? $value['discount']/100 : "0");
					$sql = "insert into "._DB_PREFIX_."specific_price (id_product,reduction,reduction_type,"._DB_PREFIX_."specific_price.from,"._DB_PREFIX_."specific_price.to,groupdiscount,from_quantity) (select "._DB_PREFIX_."product.id_product,"
					.$reduction.",".$type.", 
					".($value['fromDate']==""?'NULL':"'" . date("Y-m-d",strtotime($value['fromDate'])) . "'").",
					".($value['toDate']==""?'NULL':"'" . date("Y-m-d",strtotime($value['toDate'])) . "'") . "
					,1,1 from "._DB_PREFIX_."product where id_product NOT IN (SELECT 
					 id_product from "._DB_PREFIX_."specific_price WHERE groupdiscount=1) AND id_category_default=".$key.");";
					Db::getInstance()->Execute($sql);
					$sql = "UPDATE "._DB_PREFIX_."product SET  
								on_sale='" . ($value['displayOnSale'] == 1 ? "1":"0") ."' 
								WHERE id_category_default=" . $key;
					Db::getInstance()->Execute($sql);
					Discount::_updateCategoryDiscount($key,$value);
				}
			}
		}
		// products
		if(is_array($groups['products'])) {
			foreach($groups['products'] as $key=>$value) {
				if($value['reductionAmount'] != "" || $value['reductionPercent'] != "") {
					if ($value['reductionPercent'] != "")
					{
						$type='"percentage"';
						$reduction=($value['reductionPercent'] != "" ? $value['reductionPercent']/100 : "0");
					}
					else
					{
						$type='"amount"';
						$reduction=($value['reductionAmount'] != "" ? $value['reductionAmount'] : "0");
					}

					// Fix: since this trumps any category level pricing, we will go ahead and erase any previous pricing
					$sql = "DELETE FROM "._DB_PREFIX_."specific_price WHERE groupdiscount=1 and id_product=" . $key;
					Db::getInstance()->Execute($sql);
					
					$sql = "INSERT "._DB_PREFIX_."specific_price SET groupdiscount=1, from_quantity=1, id_product=" . $key.",
					reduction=".$reduction.",reduction_type=".$type.", "._DB_PREFIX_."specific_price.from
					=" . ($value['fromDate']==""?'NULL':"'" . date("Y-m-d",strtotime($value['fromDate'])) . "'") . ", "._DB_PREFIX_."specific_price.to
					=" . ($value['toDate']==""?'NULL':"'" . date("Y-m-d",strtotime($value['toDate'])) . "'") . ";";
					Db::getInstance()->Execute($sql);
					$sql = "UPDATE "._DB_PREFIX_."product SET 
								on_sale=" . ($value['displayOnSale'] == 1 ? "1":"0") ." 
								WHERE id_product=" . $key. ";";
					Db::getInstance()->Execute($sql);
				}

				if ($value['newPriceAmount'] != "" )
				{
					$sql = "UPDATE "._DB_PREFIX_."product SET 
								price=" . ($value['newPriceAmount'] != "" ? $value['newPriceAmount'] : "0") . " 
								WHERE id_product=" . $key. ";";								
					Db::getInstance()->Execute($sql);
					$sql = "UPDATE "._DB_PREFIX_."product SET 
								on_sale=" . ($value['displayOnSale'] == 1 ? "1":"0") ." 
								WHERE id_product=" . $key. ";";
					Db::getInstance()->Execute($sql);
				}
				if ($value['displayOnSale'] == 1)
				{
					$sql = "UPDATE "._DB_PREFIX_."product SET 
								on_sale=" . ($value['displayOnSale'] == 1 ? "1":"0") ." 
								WHERE id_product=" . $key. ";";
					Db::getInstance()->Execute($sql);
				}
			}
		}
		
		
	}

	public function postProcess() {
		global $currentIndex;
		if($_POST['post'] == "1") {
			foreach($_POST as $key=>$value) {
				// CRP, check if we have a new price 
				if(substr($key,0,strlen("newPriceBox_")) == "newPriceBox_") {
					$id = substr($key,strlen("newPriceBox_"));
					$newPriceValue = $_POST["newPriceBox_$id"];
					if($newPriceValue > 0) {
						$this->groups['products'][$id]['newPriceAmount'] = $newPriceValue;
					}
				}
				if(substr($key,0,strlen("discountCategory_")) == "discountCategory_" && trim($value) != "") {
					$id = substr($key,strlen("discountCategory_"));
					if(!is_numeric($value) || $value < 0 || $value > 100) $this->errors[] = Tools::displayError("ID [$id] is not set properly");
					// check for dates
					try {
						if($value == 0) {
							$_POST["dateFromCategory_$id"] = "";
							$_POST["dateToCategory_$id"] = "";
							$_POST["displayOnCategorySale_$id"] = "";
						} elseif($_POST["dateFromCategory_$id"] == "" || $_POST["dateToCategory_$id"] == "") {
							$this->errors[] = Tools::displayError("ID [$id], date or dates are not properly set");
						} else {
							$fromDate = strtotime($_POST["dateFromCategory_$id"]);
							$toDate = strtotime($_POST["dateToCategory_$id"]);
							$yesterday = strtotime("-1 day");
							if($toDate < $yesterday) Tools::displayError("ID[$id], discount to date can not be in past");
							if($toDate < $fromDate) Tools::displayError("ID[$id], discount to date can not smaller date then from date");
						}
					} catch(Exception $err) {
						$this->errors[] = Tools::displayError("ID [$id], error occurred: $err");
					}
					$this->groups['categories'][$id]['discount'] = $value;
					$this->groups['categories'][$id]['fromDate'] = $_POST["dateFromCategory_$id"];
					$this->groups['categories'][$id]['toDate'] = $_POST["dateToCategory_$id"];
					$this->groups['categories'][$id]['displayOnSale'] = $_POST["displayOnCategorySale_$id"];
				}
				if(substr($key,0,strlen("discountBox_")) == "discountBox_") {
					$id = substr($key,strlen("discountBox_"));
					$percentValue = $_POST["discountBox_$id"];
					$priceValue = $_POST["discountPriceBox_$id"];
					$boSkip = true;
					if($percentValue > 0 && $priceValue > 0) {
						Tools::displayError("- ID[$id], you have to fill only one of two discount fields");
					} elseif($percentValue > 0) {
						$this->groups['products'][$id]['reductionPercent'] = $percentValue;
						$boSkip = false;
					} elseif($priceValue > 0) {
						$this->groups['products'][$id]['reductionAmount'] = $priceValue;
						$boSkip = false;
					} elseif ($percentValue == 0) {
						$this->groups['products'][$id]['reductionPercent'] = $percentValue;
						$_POST["dateFromProduct_$id"] = "";
						$_POST["dateToProduct_$id"] = "";
						$_POST["displayOnProductSale_$id"] = "";				
						$boSkip = false;
					}
					if(($percentValue > 0 || $priceValue > 0) && ($_POST["dateFromProduct_$id"] == "" || $_POST["dateToProduct_$id"] == "")) {
						$this->errors[] = Tools::displayError("- ID[$id], date or dates are not properly set");
					}
					if(! $boSkip) {
						$fromDate = strtotime($_POST["dateFromProduct_$id"]);
						$toDate = strtotime($_POST["dateToProduct_$id"]);
						$yesterday = strtotime("-1 day");
						if($toDate < $yesterday) Tools::displayError("ID[$id], discount to date can not be in past");
						if($toDate < $fromDate) Tools::displayError("ID[$id], discount to date can not smaller date then from date");
						$this->groups['products'][$id]['fromDate'] = $_POST["dateFromProduct_$id"];
						$this->groups['products'][$id]['toDate'] = $_POST["dateToProduct_$id"];	
						$this->groups['products'][$id]['displayOnSale'] = $_POST["displayOnProductSale_$id"];
					}
				}
			}
			if(sizeof($this->errors) == 0) {
				Discount::setGroupDiscountValue($this->groups);
				Discount::updateDiscounts();
				// CRP - comment next line to avoid refreshing of page for test purposes
				 Tools::redirectAdmin($currentIndex.'&add'.$this->table.'&'.$this->identifier.'='.Tools::getValue($this->identifier).'&conf=4&token='.($token != NULL ? $token : $this->token));
			}
		}else {
			$this->groups = Discount::getGroupDiscountValue();
			$products = Product::getProducts($this->defaultLanguage,0,0,"id_product","ASC");
			$sql = "SELECT id_category, id_parent FROM "._DB_PREFIX_."category ORDER BY level_depth";
			$categories = Db::getInstance()->ExecuteS($sql);
			
			foreach($products as $key=>$value) {
				// if reduction_price > 0, it has to be in groups' array or added
				if($value['reduction_price'] > 0) {
					$this->groups['products'][$value['id_product']]['reductionAmount']=$value['reduction_price'];
					$this->groups['products'][$value['id_product']]['reductionPercent'] = ""; 
					$this->groups['products'][$value['id_product']]['displayOnSale'] = $value['on_sale']; 
					$this->groups['products'][$value['id_product']]['fromDate'] = date('j M Y',strtotime($value['reduction_from'])); 
					$this->groups['products'][$value['id_product']]['toDate'] = date('j M Y',strtotime($value['reduction_to'])); 
					
				} elseif($value['reduction_price'] == 0 &&  $value['reduction_percent'] == 0) {
					$gv = $this->getGroupValue($categories,$value['id_default_category']);
					if($gv != NULL && $gv['discount'] != 0) {
						$this->groups['products'][$value['id_product']]['reduction_percent'] = 0; 
						$this->groups['products'][$value['id_product']]['reductionAmount'] = ""; 
						$this->groups['products'][$value['id_product']]['fromDate'] = ""; 
						$this->groups['products'][$value['id_product']]['toDate'] = ""; 
						$this->groups['products'][$value['id_product']]['displayOnSale'] = 0; 
					}
				} elseif ($value['reduction_percent'] > 0) { 
					$gv = $this->getGroupValue($categories,$value['id_category_default']);
					if($gv['displayOnSale'] == NULL) $gv['displayOnSale'] = 0;
					if($gv['discount'] != $value['reduction_percent'] 
						|| $gv['fromDate'] != date('j M Y',strtotime($value['reduction_from']))
						|| $gv['toDate'] != date('j M Y',strtotime($value['reduction_to']))
						|| $gv['displayOnSale'] != $value['on_sale']) {
							
							$this->groups['products'][$value['id_product']]['reductionPercent'] = $value['reduction_percent']; 
							$this->groups['products'][$value['id_product']]['displayOnSale'] = $value['on_sale']; 
							$this->groups['products'][$value['id_product']]['fromDate'] = date('j M Y',strtotime($value['reduction_from'])); 
							$this->groups['products'][$value['id_product']]['toDate'] = date('j M Y',strtotime($value['reduction_to'])); 
						}
				}
			}
		}
	}
	
	private function getGroupValue(&$categories,$id_category) {
		foreach($categories as $cat=>$category) {
			if($category['id_category'] == $id_category) {
				$boFound = false;
				if(is_array($this->groups['categories'])) {
					foreach($this->groups['categories'] as $key=>$group) {
						if($key == $id_category) {
							if($group['discount'] == "") {
								return $this->getGroupValue($categories,$category['id_parent']);
							} else {
								return $group;
							}
						}
					}
				}
				return $this->getGroupValue($categories,$category['id_parent']);
			}
			
		}
		return NULL;
	}

	public function displayErrors()
	{
		if ($nbErrors = sizeof($this->errors))
		{
			echo '<div class="alert error"><h3>'.$nbErrors.' '.($nbErrors > 1 ? $this->l('errors') : $this->l('error')).'</h3>
			<ol style="margin-left: 30px;">';
			foreach ($this->errors AS $error)
				echo '<li>'.$error.'</li>';
			echo '
			</ol></div>';
		} 
	}

	public function display()
	{
		global $currentIndex, $cookie;
		
		echo '
		<link rel="stylesheet" type="text/css" href="../modules/groupdiscount/css/jquery-ui-1.8.custom.css">
		<link rel="stylesheet" type="text/css" href="../modules/groupdiscount/css/groupdiscount.css">
		<script type="text/javascript" src="../modules/groupdiscount/js/jquery-ui-1.8.custom.min.js"></script>
		<script langauge="javascript">
			$(function() {
				$(".datepicker").datepicker(
							{
								dateFormat: \'d M yy\',
								minDate:0
							}				
								);
			});
			
			function discountBoxChanged(obj) {
				var id = obj.id.substr(obj.id.lastIndexOf("_")+1);
				if(obj.value == "0") {
					$("#dateFromProduct_" + id).val("");
					$("#dateToProduct_" + id).val("");
					$("#displayOnProductSale_" + id).attr("checked",false);
				} else if(obj.value != "") {
					$("#discountPriceBox_" + id).val("");
					this.setDiscountProductDate(id);
				}
			}
			function discountPriceBoxChanged(obj) {
				var id = obj.id.substr(obj.id.lastIndexOf("_")+1);
				if(obj.value != "") {
					$("#discountBox_" + id).val("");
					this.setDiscountProductDate(id);
				}
			}
			function discountCategoryBoxChanged(obj) {
				var id = obj.id.substr(obj.id.lastIndexOf("_")+1);
				if(obj.value != "") {
					var dateFrom = $("#dateFromCategory_" + id).datepicker("getDate");
					var dateTo = $("#dateToCategory_" + id).datepicker("getDate");
					if(! dateFrom) $("#dateFromCategory_" + id).datepicker("setDate","0d");
					if(! dateTo) $("#dateToCategory_" + id).datepicker("setDate","5y");
				}
			}
			function setDiscountProductDate(id) {
				var dateFrom = $("#dateFromProduct_" + id).datepicker("getDate");
				var dateTo = $("#dateToProduct_" + id).datepicker("getDate");
				if(! dateFrom) $("#dateFromProduct_" + id).datepicker("setDate","0d");
				if(! dateTo) $("#dateToProduct_" + id).datepicker("setDate","5y");
			}
		</script>
		<div class="tab-page" id="step1">
			<h3>'.$this->l('Group Discount').'</h4>
			';
			echo '<br />' .  $this->l('Products are linked with default category');
			$categories = Category::getCategories(intval($cookie->id_lang), false);
			echo '	
			<hr class="clear"/>
			<br />
			<form action="'.$currentIndex.'&token='.($token != NULL ? $token : $this->token).'" method="post" enctype="multipart/form-data" name="product" id="product">
				<input name="post" type="hidden" value="1" />
	
				<div style="overflow: auto; min-height: 200px; padding-top: 0.6em; margin-bottom:10px" id="categoryList">
				<table cellspacing="0" cellpadding="0" class="table">
						<tr>
							<th style="width:30px; border-right:1px solid #999; text-align:center; font-size:11px">'.$this->l('ID').'</th>
							<th style="width:550px; border-right:1px solid #999; text-align:left; font-size:11px">'.$this->l('Categories & Products').'</th>
							<th style="width:65px; border-right:1px solid #999; text-align:center; font-size:11px">'.$this->l('Whole sale price').'</th>
							<th style="width:65px; border-right:1px solid #999; text-align:center; font-size:11px">'.$this->l('Price with taxes').'</th>
							<th style="width:65px; border-right:1px solid #999; text-align:center; font-size:11px">'.$this->l('New price').'</th>
							<th style="width:65px; border-right:1px solid #999; text-align:center; font-size:11px">'.$this->l('From date').'</th>
							<th style="width:65px; border-right:1px solid #999; text-align:center; font-size:11px">'.$this->l('To date').'</th>
							<th style="width:50px; border-right:1px solid #999; text-align:center; font-size:11px">'.$this->l('Discount Amount').'</th>
							<th style="width:50px; border-right:1px solid #999; text-align:center; font-size:11px">'.$this->l('Discount %').'</th>
						</tr>';
		$done = array();
		$index = array();
		$indexedCategories =  isset($_POST['categoryBox']) ? $_POST['categoryBox'] : array();
		foreach ($indexedCategories AS $k => $row) 
			$index[] = $row['id_category'];
		$this->recurseCategoryForInclude($index, $categories, $categories[0][1], 1);
		echo '
				</table>
				
				</div>
				<input type="submit" value="'.$this->l('Save discounts').'" name="submitAdd'.$this->table.'" class="button" />
			';
			
			echo('</table></form>');
			
			echo('<div style="width:100%; text-align:right; padding-top:30px; clear:both"><a target="_blank" href="mailto:radepopovic@gmail.com"><u style="font-size:9px;color:blue">radepopovic@gmail.com</u></a>');
	}
	
	function recurseCategoryForInclude($indexedCategories, $categories, $current, $id_category = 1, $id_category_default = NULL)
	{
		global $done;
		static $irow;
		$id_obj = intval(Tools::getValue($this->identifier));

		if (!isset($done[$current['infos']['id_parent']]))
			$done[$current['infos']['id_parent']] = 0;
		$done[$current['infos']['id_parent']] += 1;

		$todo = sizeof($categories[$current['infos']['id_parent']]);
		$doneC = $done[$current['infos']['id_parent']];

		$level = $current['infos']['level_depth'] + 1;
		//if($level == 2) $level = 1;
		$img = $level == 1 ? 'lv1.png' : 'lv'.$level.'_'.($todo == $doneC ? 'f' : 'b').'.png';

		echo '
		<tr class="'.($irow++ % 2 ? 'alt_row' : 'alt_row').'">
			<td>
				'.$id_category.'
			</td>
			<td>
				<img src="../img/admin/'.$img.'" alt="" /> &nbsp;<label for="categoryBox_'.$id_category.'" class="t">'.stripslashes(Category::hideCategoryPosition($current['infos']['name'])).'</label>
			</td>
			<td>&nbsp;</td>
			<td>&nbsp;</td>
			<td>&nbsp;</td>
			<td><input name="dateFromCategory_'.$id_category.'" id="dateFromCategory_'.$id_category.'" class="datepicker" type="text" value="' . $this->groups['categories'][$id_category]['fromDate']  . '" /></td>
			<td><input name="dateToCategory_'.$id_category.'" id="dateToCategory_'.$id_category.'" class="datepicker" type="text" value="' . $this->groups['categories'][$id_category]['toDate']  . '" /></td>
			<td>-</td>
			<td>
				<input type="textbox" onchange="discountCategoryBoxChanged(this)" class="discountTextBox" name="discountCategory_'.$id_category.'" id="discountCategory_'.$id_category.'" value="' . $this->groups['categories'][$id_category]['discount']  . '"  /> %
			</td>		
			</tr>';
		if($this->showProducts($id_category,$level)) $irow = 1;

		if (isset($categories[$id_category]))
			foreach ($categories[$id_category] AS $key => $row)
				if ($key != 'infos')
					$this->recurseCategoryForInclude($indexedCategories, $categories, $categories[$id_category][$key], $key);
	}
	
	private function showProducts($id_category,$level) {
		$level++;
		$sql = "SELECT p.id_product,pl.name,p.price, p.wholesale_price FROM "._DB_PREFIX_."product p, "._DB_PREFIX_."product_lang pl
				WHERE p.id_product = pl.id_product and id_lang='$this->defaultLanguage' AND p.id_category_default=$id_category" ;
		$products = Db::getInstance()->ExecuteS($sql);
		foreach($products as $key=>$product) {
			$img = $level == 1 ? 'lv2_b.png' : 'lv'.$level.'_'.($products[sizeof($products)-1]['id_product'] == $product['id_product'] ? 'f' : 'b').'.png';
			$id_product = $product['id_product'];
			
			// MODIFIED BY Judith Buetas TO Grandes Zapatos
		
		$price = $product['price'];
		
		$id_currency = Configuration::get('PS_CURRENCY_DEFAULT');
		$price = Tools::convertPrice($price, $id_currency);

		//Use Tax
		$use_tax = true;
		if (Tax::excludeTaxeOption())
			$use_tax = false;

		// retrieve address informations
		$id_country = (int)Country::getDefaultCountryId();
		$id_state = 0;
		$id_county = 0;

		// TaxRate calculation
		$tax_rate = Tax::getProductTaxRateViaRules((int)$id_product, (int)$id_country, (int)$id_state, (int)$id_county);
		if ($tax_rate === false)
			$tax_rate = 0;

		// Add Tax
		if ($use_tax)
		{
			$price = $price * (1 + ($tax_rate / 100));
		}
		
		$price = Tools::ps_round($price, 2);
		
		$product['price']  = $price;
		
		///END  MODIFIED BY Judith Buetas
			echo('
			<tr >
				<td style="font-size:9px">
					--'.$id_product.'
				</td>
				<td>
					<img src="../img/admin/'.$img.'" alt="" /> &nbsp; <img src="../img/admin/tab-products.gif" alt="" /> &nbsp;<label for="productBox_'.$id_product.'" class="t">'.$product['name'].'</label>
				</td>
				<td>
					'. number_format($product['wholesale_price'],2) .'
				</td>
				<td>
					'. number_format($product['price'],2) .'
				</td>
			<td>
					<input type="textbox" class="newPriceTextBox" name="newPriceBox_'.$id_product.'" id="newPriceBox_'.$id_product.'"  />
			</td>				
				<td>
					<input name="dateFromProduct_'.$id_product.'" id="dateFromProduct_'.$id_product.'" class="datepicker" type="text" value="' . $this->groups['products'][$id_product]['fromDate']  . '" />
				</td>
				<td>
					<input name="dateToProduct_'.$id_product.'" id="dateToProduct_'.$id_product.'" class="datepicker" type="text" value="' . $this->groups['products'][$id_product]['toDate']  . '" /></td>
				<td>
					<input type="textbox" onchange="discountPriceBoxChanged(this)" class="discountTextBox" style="width:60px" name="discountPriceBox_'.$id_product.'" id="discountPriceBox_'.$id_product.'" value="' . $this->groups['products'][$id_product]['reductionAmount']  . '"  />
				</td>
				<td>
					<input type="textbox" onchange="discountBoxChanged(this)" class="discountTextBox" name="discountBox_'.$id_product.'" id="discountBox_'.$id_product.'" value="' . $this->groups['products'][$id_product]['reductionPercent']  . '"  /> %
				</td>
			</tr>	
			');	
		}
		return (sizeof($products) > 0);
	}


}

?>