<?php
/* +--------------------------------------------------------+
 * |														|
 * |	Group-discount module @2010 , version 1.0.0			|
 * |	rade.popovic@gmail.com								|
 * |														|
 * |	All rights reserved									|
 * |														|
 * | 	No Warranty											|
 * |	Unless otherwise stated, the software on 			|
 * |	this module is provided "as-is," without any 		|
 * |	express or implied warranty. In no event I shall be |
 * |	held liable for any damages arising from the use of |
 * |	the software.										|
 * +--------------------------------------------------------+
 */

class GroupDiscount extends Module {
			
	function __construct() {
		$this->name = 'groupdiscount';
		parent::__construct();
		
		$this->tab = 'pricing_promotion';
		$this->version = '1.0.0';
		$this->displayName = $this->l('GroupDiscount');
		$this->description = $this->l('Easily discount all products, categories, sub-categories or single product.');
		$this->confirmUninstall = $this->l('Are you sure you want to uninstall GroupDiscount module ?');
	}

	public function install(){
	  $languages = Language::getLanguages();
	  $discountTab = array();
	  foreach($languages as $key=>$one_language) {
	  	$discountTab[$one_language['id_lang']] = "GroupDiscount";
	  }
	  //GROUPDISCOUNT_GROUPS buuu es una var de configuracion con unos valores muy raros
	  if(!parent::install() 
	  	|| !Configuration::updateValue('GROUPDISCOUNT_GROUPS', '')
	  	|| !$this->installGroupDiscountTab('Discount', $discountTab,1)) return false;
	  return true;
	} 
	
	
		
	public function uninstall() {
	  if(!parent::uninstall()  
	    || !$this->uninstallModuleTab('Discount'))
	    //return false;
	  return true;
	} 
	
	private function installGroupDiscountTab($tabClass, $tabName, $idTabParent) {
	  // search for prosynch module
	  $prosynch_module = false;
	  $check_tabs = Tab::getTabs();
	  foreach($check_tabs as $key=>$one_tab) {
	  	if($one_tab['module'] == 'prosynch') {
	  		$prosynch_module = true;
	  		break;
	  	}
	  }
	  @copy(_PS_MODULE_DIR_.$this->name.'/logo.gif', _PS_IMG_DIR_.'t/'.$tabClass.'.gif');
	  $tab = new Tab();
	  $tab->name = $tabName;
	  $tab->class_name = $tabClass;
	  $tab->module = $this->name;
	  $tab->id_parent = $idTabParent;
	  if($tab->save()) {
		  $tab->position = ($prosynch_module) ? 3 : 2;
		  $tab->move('l');
		  return true;
	  } else {
	  	  return false;
	  }
	} 
	
	public function getContent() {
		$this->_html = '<img src="../modules/groupdiscount/groupdiscount_big.png" style="float:left; margin-right:5px; margin-left:10px" /><h2>Group Discount:: ver.' . $this->version . '</h2>';
		$this->_html .= '
		<div style="float: left; width: 540px; height: 250px; border: dashed 1px #666; padding: 8px; margin-left: 12px;">
			<h2>'.$this->l('Group Discount').'</h2>
			<div style="clear: both;"></div>
			<p>'.$this->l('You can easily discount all products, categories, sub-categories and single product. Just click on Catalog->GroupDiscount.').'<br />
			'.$this->l('Put the discount values in categories which have discount and click Save button.').'<br />
			'.$this->l('That\'s it.').'<br /><br />
			'.$this->l('Discounts are saved hierarchically, that means if you fill the value of the category which has sub categories, then the sub categories will also have the same amount of discount as parent category').'
			'.$this->l('If you do not want the discount for any child category, simply write 0 in child category\'s value.').'<br /><br />
			<a href="../modules/groupdiscount/groupDiscountHelp.pdf'.'" style="text-decoration: underline;" target="_blank">'.$this->l('See user manual').'</a><br />
			'.$this->l('Contact').': <a class="green" href="mailto:rade.popovic@gmail.com">rade.popovic@gmail.com</a>
		</div>
		<div style="float: left; width: 300px; height: 250px; border: dashed 1px #666; padding: 8px; margin-left: 12px;clear:right;">
			<h2>'.$this->l('Thank you for using the module').'</h2>
			<p>'.$this->l('I hope it will be usefull and it will simplified the discount management<br />Be free to contact me regarding any bug,question, improvement or comment'). '</p>							 
		</div>
		<div style="clear:both; height:20px">&nbsp;</div>';
		$this->_html .= '
		<div style="clear:both;">&nbsp;</div>
		<div style="width:100%; margin-top:20; padding: 8px;font-size:9px">
		<h2>'.$this->l('No Warranty').'</h2>
		'.$this->l('Unless otherwise stated, the software on this module is provided "as-is," without any express or implied warranty. In no event I shall be held liable for any damages arising from the use of the software.').'
		<h2></h2>		
		</div>
		';
		return $this->_html;
	}
	
	private function uninstallModuleTab($tabClass) {
	  $idTab = Tab::getIdFromClassName($tabClass);
	  if($idTab > 0) {
	    $tab = new Tab($idTab);
	    $tab->delete();
	    return true;
	  }
	  return false;
	}	

}
?>