<?php
/*
Author: Judith Buetas Solanellas
Date: 28/11/2011
Shop Feedback SQL
*/

if (!defined('_CAN_LOAD_FILES_'))
	exit;

class ShopFeedbackSql extends ObjectModel
{
// @var string comment
	public 		$comment;
	
//@var string comment_grade
	public 		$comment_grade;
	
	protected 	$table = 'shop_feedback';
	protected 	$identifier = 'id_feedback_comment';
	
	/**
	* Return number of comments
 	*
 	* @return int Info
 	*/
	static public function getFeedbackCommentsNumber()
	{
		$aData = Db::getInstance()->ExecuteS('SELECT COUNT(`id_feedback_comment`) as count_comments FROM `'._DB_PREFIX_.'shop_feedback`');		
		return ($aData[0]['count_comments']);
	}
	
	/**
	* Validate a comment
 	*
	* @return boolean succeed
 	*/
	public function validate($validate = '1')
	{
		if (!Validate::isUnsignedId($this->id))
			die(Tools::displayError());

		return (Db::getInstance()->Execute('
		UPDATE `'._DB_PREFIX_.'shop_feedback` SET
		`validate` = '.(int)($validate).'
		WHERE `id_feedback_comment` = '.(int)($this->id)));
	}
		
	/**
	* Get data of shop_feedback by id_feedback_comment
	* @return array Comments
	*/
	static public function getByFeedbackCommentId($id_feedback_comment)
	{
		global $cookie;

		$sql = 'SELECT fc.`id_feedback_comment`, IF(c.id_customer, CONCAT(c.`firstname`, \' \',  c.`lastname`), fc.customer_name) customer_name, fc.`comment`, fc.`grade`, fc.`date_add`, fc.`validate`
				FROM `'._DB_PREFIX_.'shop_feedback` fc
				LEFT JOIN `'._DB_PREFIX_.'customer` c ON (c.`id_customer` = fc.`id_customer`) 
				WHERE 
				fc.`id_feedback_comment` = '.$id_feedback_comment;

		return (Db::getInstance($sql)->ExecuteS($sql));
	}
	
	/**
	* Get comments by Validation
	*
	* @return array Comments
	*/
	static public function getByValidate($validate = '0', $deleted = false, $orderby=NULL)
	{
		global $cookie;
		
		if(!isset($orderby))
		{
			$orderby = 'ORDER BY fc.`date_add` DESC';
		}
		
		$sql = 'SELECT fc.`id_feedback_comment`, IF(c.id_customer, CONCAT(c.`firstname`, \' \',  c.`lastname`), fc.customer_name) customer_name, fc.`comment`, fc.`grade`, fc.`date_add`, fc.`validate`
				FROM `'._DB_PREFIX_.'shop_feedback` fc
				LEFT JOIN `'._DB_PREFIX_.'customer` c ON (c.`id_customer` = fc.`id_customer`) 
				WHERE fc.`validate` = '.(int)($validate).' '.$orderby;

		return (Db::getInstance()->ExecuteS($sql));
	}

// Judith Buetas Solanellas	
// 29/11/2011
// Get all comments
// @return array Comments
	static public function getAllComments($start = 0, $limit = NULL)
	{
		global $cookie;

		$sql = 'SELECT fc.`id_feedback_comment`, IF(c.id_customer, CONCAT(c.`firstname`, \' \',  c.`lastname`), fc.customer_name) customer_name, fc.`comment`, fc.`grade`, fc.`date_add`, fc.`validate`
		FROM `'._DB_PREFIX_.'shop_feedback` fc
		LEFT JOIN `'._DB_PREFIX_.'customer` c ON (c.`id_customer` = fc.`id_customer`) 
		ORDER BY fc.`date_add` DESC
		'.($limit ? 'LIMIT '.(int)($start).', '.(int)($limit) : '');

		return (Db::getInstance()->ExecuteS($sql));
	}
	
// Judith Buetas Solanellas	
// 29/11/2011
// Edit a comment
// @return boolean succeed
	public function update()
	{
		if (!Validate::isUnsignedId($this->id))
			die(Tools::displayError());
		
		$sql = 'UPDATE `'._DB_PREFIX_.'shop_feedback` SET
		`comment` = \''.$this->comment.'\',
		`grade` = '.$this->comment_grade.',
		`validate` = '.$this->validate.'
		WHERE `id_feedback_comment` = '.(int)($this->id);

		return (Db::getInstance()->Execute($sql));
	}

// Judith Buetas Solanellas	
// 01/12/2011
// Add a comment
// @return boolean succeed
	public function add()
	{
		$sql = 'INSERT INTO `'._DB_PREFIX_.$this->table.'` 
				(`id_customer`,`id_guest`,`customer_name`,`comment`,`grade`,`date_add`,`validate`) 
				VALUES 
				('.$this->id_customer.','.$this->id_guest.',\''.$this->customer_name.'\',\''.$this->comment.'\','.$this->grade.',\''.$this->date_add.'\','.$this->validate.')';

		return (Db::getInstance()->Execute($sql));
	}
	
// Judith Buetas Solanellas	
// 01/12/2011
// Return the last comment values
// @return array Comments
	 public function getLastComment()
	{
		$aData = Db::getInstance()->getRow('SELECT * FROM `'._DB_PREFIX_.$this->table.'` 
											WHERE `id_feedback_comment` = (SELECT MAX(id_feedback_comment) FROM `'._DB_PREFIX_.$this->table.'`)');
		return ($aData);
	}

	/**
	* Get comments by Validation
	*
	* @return array Comments
	*/ 
	
	public function getNumFeedbackCommentsValidate($validate = '0',$star='',$filter='', $count = true, $num_row=NULL,$number_comments_per_page=NULL)
	{
		global $cookie;

		$fields = '*';
		if($count)
		{
			$fields = 'count(*) AS count_rows';
		}
		
		$query = 'SELECT '.$fields.' FROM `'._DB_PREFIX_.'shop_feedback` '.
                ' WHERE `validate` = '.(int)$validate;

		if($star != '')
		{
			$query .= (($star != "-1" AND $star != "") ? " AND `grade` = ".$star : "");
		}
		
		if($filter != '')
		{
			$query .= ($filter == "true_date"  ? " ORDER BY `date_add` ASC " : "").
                 	(($filter == "false_date" OR $filter == "")? " ORDER BY `date_add` DESC " : "").
                 	($filter == "true_rating" ? " ORDER BY `grade` ASC " : "").
                 	($filter == "false_rating" ? " ORDER BY `grade` DESC " : ""); 
		}

		if(isset($num_row) && isset($number_comments_per_page))
		{
			$query .= ' LIMIT '.$num_row." , ".$number_comments_per_page;            
		}

		return (Db::getInstance()->ExecuteS($query));
	}         
	
	/**
	* Get total Rating
	*
	* @return array Comments
	*/ 
	
	public function getTotalRating($validate = '0')
	{
		global $cookie;

		$query = 'SELECT ((SUM(grade))/(COUNT(*))) AS total_rating_grade FROM `'._DB_PREFIX_.$this->table.'` '.
                ' WHERE `validate` = '.(int)$validate;
          
		return (Db::getInstance()->ExecuteS($query));
	}
    
    /**
	* Get Rating by value star
	*
	* @return array Comments
	*/ 
	
	public function getRatingByStars($validate = '0')
	{
		global $cookie;

		$query = 'SELECT count(id_feedback_comment) AS total_rows, grade FROM `'._DB_PREFIX_.$this->table.'` '.
                ' WHERE `validate` = '.(int)$validate.
                 ' GROUP BY `grade` '.
        		 ' ORDER BY `grade` DESC ';

		return (Db::getInstance()->ExecuteS($query));
	}
	
// Judith Buetas Solanellas	
// 26/12/2011
// Edit a comment
// @return boolean succeed	
	
	//get row from addhopFeedbackOrderCommentsEmails if we have sent the remember email
	//Return array 
	public function checkShopFeedbackOrderCommentsWithMails($id_order)
	{
		global $cookie;
			
		$sql = 'SELECT * FROM `'._DB_PREFIX_.'shop_feedback_remember_emails` WHERE id_order='.$id_order; 
		return (Db::getInstance()->ExecuteS($sql));
	}
		
	//Add a row in addhopFeedbackOrderCommentsEmails
 	//return boolean succeed
 	public function addhopFeedbackOrderCommentsEmails()
	{
		if (!Validate::isUnsignedId($this->id))
			die(Tools::displayError());
		
		$sql = 'INSERT INTO `'._DB_PREFIX_.'shop_feedback_remember_emails` 
				(`id_order`, `send`) 
				VALUES 
				('.$this->id.','.$this->send.')';

		return (Db::getInstance()->Execute($sql));
	}
}
?>