/*
* 2011 Judith Buetas Solanellas
*
* NOTICE OF LICENSE
*
* This source file is subject to the Academic Free License (AFL 3.0)
* that is bundled with this package in the file LICENSE.txt.
* It is also available through the world-wide-web at this URL:
* http://opensource.org/licenses/afl-3.0.php
* If you did not receive a copy of the license and are unable to
* obtain it through the world-wide-web, please send an email
* to license@prestashop.com so we can send you a copy immediately.
*
* DISCLAIMER
*
* Do not edit or add to this file if you wish to upgrade PrestaShop to newer
* versions in the future.
*
*  @author Judith Buetas Solanellas <jbuetass@uoc.edu>
*  @copyright  2011 Judith Buetas Solanellas
*  @date 29/11/2011
*  @version  Release: $Revision: 1.0 $
*  @license    http://opensource.org/licenses/afl-3.0.php  Academic Free License (AFL 3.0)
*/

var limitCharacters = 140;
var cptCorreto=false;

$(function(){
	//el enlace nos envia al listado de comentarios
	$('#view_feedback').click(function(){
        $('#view_feedback_form').submit();
    });

    //muestra la imagen del captcha en el dialog
	$('#imgCaptchaFeedback').click(function(){
		$(this).attr("src", feedback_dir + 'capchapepean.php');
	});
    
    //el dialogo no se muestra inicialmente
	$("#FeedbackCommentDialog" ).dialog({
		autoOpen: false,
		width:350,
		modal: true
	});
	
	 //al clicar el boton 'danos tu opinión' se abre el dialogo
	$('#btnDisplayFeedbackComment').click(function(){
		displayFeedbackDialog();
	});

	 //cierra el dialog con el botón cancelar
	$('#btnCancelFeedbackDialog').click(function(){     
		$("#FeedbackCommentDialog"  ).dialog( "close" );
		cleanFormFeedbackDialog();
	});
    
    //control numero caracteres comentario	
	$('#charactersFeedbackDialog').html(limitCharacters);	
	$('#txtCommentFeedbackDialog')
		.keyup(function(){
		var $count = $(this).val().length;
		$count = limitCharacters - $count;
		$('#charactersFeedbackDialog').html($count); 
	});
	
	//al clicar el boton 'guardar' añadimos el comentario a la tabla de la BD
	$('#btnSaveFeedbackDialog').click(function(){
		saveCommentFeedback();  
	});

	//cambia los radio buttons a links especiales
	//$("input[type=radio].star").rating(); 
	$("input[name=radioCommentGradeFeedbackDialog]").rating();
	$("input[name=radioTotalCommentGradeFeedbackDialog]").rating();
	$("input[name^=radioListCommentGradeFeedbackDialog]").rating();
	
	$('.auto-submit-star').rating({
				callback: function(value, link){
				}
			});
			
	//mostramos el dialogo de añadir comentarios
	function displayFeedbackDialog(){
		$('#FeedbackCommentDialog').dialog( "open" );
		$('#imgCaptchaFeedback').attr("src", feedback_dir + 'capchapepean.php');
		return false;
	}
	
	//limpiamos los datos del formulario del dialogo
	function cleanFormFeedbackDialog(){
		$('#txtCustomerNameFeedbackDialog').val('');
    	$('#txtCommentFeedbackDialog').val('');
    	$('#charactersFeedbackDialog').html(limitCharacters);
    	$("input[name=radioCommentGradeFeedbackDialog]").empty();
    	$('#txtCaptchaFeedbackDialog').val('');
	}

	//guardamos el comentario
	function saveCommentFeedback(){ 
		var captcha=$("#txtCaptchaFeedbackDialog").val();
		/*Hacemos las comprobaciones para que var si se puede enviar*/
		/*primero miramos que el captcha sea el correcto*/
		if(enable_captcha==true)
		{
			$.ajax({
			type: 'POST',
			url: feedback_dir + 'validarcapchapepean.php',
			async: true,
			cache: false,
			dataType : 'json',
			data: {captcha:captcha},
			success: respuestaCaptcha
			});
		}
		else
		{
			respuestaCaptcha({"checkcaptcha":"valid"});
		}		
	}

	//comprobación captcha
	function respuestaCaptcha(Data)
	{
		var rate =  $("input[name=radioCommentGradeFeedbackDialog]").val(); //is not really a radio button
		var comment = $('#txtCommentFeedbackDialog').val();
		
		if (allow_guests && $('#txtCustomerNameFeedbackDialog').val())
			var customer_name = $('#txtCustomerNameFeedbackDialog').val();
		else
			var customer_name = '';
		
		/*Si el captcha es correcto miro el resto de cosas para poder enviar*/
		if(Data.checkcaptcha=="valid")
		{		
			hayCustomerName = false;
			if (allow_guests && customer_name == "")
			{
				alert(msg_empty_customer_name);//"pon tu nombre,no puedo enviar el comentario"
			}
			else
			{
				hayCustomerName=true;	
			}
			
			hayRate=false;
			if (rate != "")
			{
				hayRate=true;	
			}
			else
			{
				alert(msg_empty_rate);//"ponme estrellicas,no puedo enviar el comentario"
			}
			
			hayComment=false;
			if (comment != "")
			{
				hayComment=true;	
			}
			else
			{
				alert(msg_empty_comment);//"tas dejao el comentario,no puedo enviar el comentario"
			}
		
			if (hayComment==true && hayRate==true){
				$.ajax({
				type: 'POST',
				url: feedback_dir + 'saveFeedbackComment.php',
				async: true,
				cache: false,
				dataType : 'html',
				data: {action:'save_FO',customer_name:customer_name,comment:comment,rate:rate},
				success: savedForm
				});
			}
		}
		else
			alert(msg_incorrect_captcha);//"El captcha ta mal,no puedo enviar el comentario"
	}
	
	//una vez guardado el comentario se cierra el diálogo del formulario
	function savedForm()
	{
		cleanFormFeedbackDialog();
		$("#FeedbackCommentDialog").dialog( "close" );
	}
	
//ShopFeedback Order Comments + Feedback	
	
	//cambia los radio buttons a links especiales
	$("input[name=radioFeedbackCommentGrade]").rating();
	$("input[name^=radioOrderCommentGrade]").rating();
	
	//al clicar el boton 'guardar' añadimos el comentario a la tabla de la BD
	$('#btnSaveOrderCommentsDialog').click(function(){
		saveOrderCommentsFeedback();  
	});
	
	//guardamos los comentarios del pedido y de la tienda
	function saveOrderCommentsFeedback(){
		
		$(".tblOrderComment").each(function(index){
			
			var dataProductComment = 'action=saveProductComment&id_product='+$(this).find("input[name=id_product]").val();
			
			var txt_title_product_comment = $(this).find("input[type=text]").val();
			
			if (!txt_title_product_comment)
			{
				alert(msg_empty_title_product_comment);//ERROR: el campo de respuesta está vacio
				return false;
			}
			
			dataProductComment += '&txt_title_product_comment='+txt_title_product_comment;
			
			var txt_content_product_comment = $(this).find("textarea").val();
			
			if (!txt_content_product_comment)
			{
				alert(msg_empty_content_product_comment);//ERROR: el campo de respuesta está vacio
				return false;
			}
			
			dataProductComment += '&txt_content_product_comment='+txt_content_product_comment;
			
			dataProductComment += '&count_criterions='+$(this).find("input[name=count_criterions]").val();
			
			$(this).find("input[name=id_criterion]").each(function(index) {
				dataProductComment += '&'+index+'id_criterion='+$(this).val();
			});
			
			$(this).find("[name^=radioOrderCommentGrade]").each(function(index) {
				dataProductComment += '&'+index+'orderCommentGrade='+$(this).val();
			});

			$.ajax({
				type: 'POST',
				url:  feedback_dir + 'shopFeedbackAllCommentsAjaxActions_FO.php',
				async: true,
				dataType : 'html',
				data: dataProductComment,
				beforeSend: function()
				{
					;//alert('antes de enviar');
				},
				success: function(Data)
				{
					;
				},
				error: function(XMLHttpRequest, textStatus, errorThrown) 
				{
					alert("TECHNICAL ERROR:\nError thrown: " + XMLHttpRequest + "\n" + 'Text status: ' + textStatus);
				}
			});
		});

		var dataFeedback = 'action=saveFeedbackComment&id_order='+id_order;
		
		var txt_feedback_comment = $('#txtFeedbackComment').val();
            
		if (!txt_feedback_comment)
		{
			alert(msg_empty_feedback_comment);//ERROR: el campo de respuesta está vacio
			return false;
		}
		
		dataFeedback += '&txt_feedback_comment='+txt_feedback_comment;
		
		var rd_feedback_comment_grade = $("input[name=radioFeedbackCommentGrade]").val();
		dataFeedback += '&rdo_feedback_comment_grade='+rd_feedback_comment_grade;
		
		$.ajax({
			type: 'POST',
			url:  feedback_dir + 'shopFeedbackAllCommentsAjaxActions_FO.php',
			async: true,
			dataType : 'html',
			data: dataFeedback,
			beforeSend: function()
			{
				;//alert('antes de enviar');
			},
			success:
				savedFormComments
			,
			error: function(XMLHttpRequest, textStatus, errorThrown) 
			{
				alert("TECHNICAL ERROR:\nError thrown: " + XMLHttpRequest + "\n" + 'Text status: ' + textStatus);
			}
		});

		return true;
	}
	var callSendToFacebook=$(".tblOrderComment").length;
	var callSendToTwitter=callSendToFacebook;
	var sendToFacebook = 0;
	var sendToTwitter = 0;
	
	function savedFormComments(Data)
	{
		var isSendToFacebook = false;
		var isSendToTwitter = false;
		
		$(".tblOrderComment").each(function(index){
			var check_facebook=$(this).find("input[name=faceBookComentPepe]").is(':checked');
       		var check_twitter=$(this).find("input[name=twitterBookComentPepe]").is(':checked');
       		var txt_content_product_comment = $(this).find("textarea").val();
			var path_product= $(this).find("a[name=pathProduct]").attr("href");
			var img_path_product=$(this).find("img[name=imgPathProduct]").attr("src");
       		
            if(check_facebook==true)
			{sendToFacebook +=1;
				isSendToFacebook = true;
	       		SendFacebook(txt_content_product_comment,path_product,img_path_product);	      
			}
			else
			{
				
				callSendToFacebook--;
				mandaAlFacebook(callSendToFacebook);
			}
			
	
			if(check_twitter==true)
			{	sendToTwitter +=1;
				isSendToTwitter = true;
	       		SendTwitter(txt_content_product_comment,path_product,img_path_product);
			}
			else
			{
				
				callSendToTwitter--;
				mandaAlTwitter(callSendToTwitter);
			}
		});
		/*
		var width  = 640;
		var height = 480;
    	var left = parseInt((screen.width / 2) - (width / 2));
    	var top = parseInt((screen.height / 2) - (height / 2));
	    var windowFeatures = "width=" + width + ",height=" + height + ",menubar=yes,toolbar=yes,scrollbars=yes,resizable=yes,left=" + left + ",top=" + top + "screenX=" + left + ",screenY=" + top;

		if(isSendToFacebook==true)
			window.open(feedback_dir + "phpfbtw/loginFacebook.php","fbpost",windowFeatures);
			
		if(isSendToTwitter==true)
			window.open(feedback_dir + "phpfbtw/logintwitter.php","twpost",windowFeatures);
			*/
		alert('Sus comentarios se han guardado satisfactoriamente');
		//window.location.href = Data;
	}
			

    function SendFacebook(message,rutaalproducto,rutaImagenProducto)
    {
    	
     	$.post(feedback_dir + 'phpfbtw/saveOrderCommentsFacebookMessages.php',{message:message,rutaalproducto:rutaalproducto,rutaImagenProducto:rutaImagenProducto,redirect:feedback_dir}
     	,function(){
     		callSendToFacebook--;
     		 mandaAlFacebook(callSendToFacebook);
     	});     
    }
    function mandaAlFacebook(callSendToFacebook)
    {
    	if((callSendToFacebook==0) && (sendToFacebook != 0))
    	{
    		var width  = 640;
			var height = 480;
    		var left = parseInt((screen.width / 2) - (width / 2));
    		var top = parseInt((screen.height / 2) - (height / 2));
	    	var windowFeatures = "width=" + width + ",height=" + height + ",menubar=yes,toolbar=yes,scrollbars=yes,resizable=yes,left=" + left + ",top=" + top + "screenX=" + left + ",screenY=" + top;
			window.open(feedback_dir + "phpfbtw/loginFacebook.php","fbpost",windowFeatures);
    	}
    }
  
    function SendTwitter(message,rutaalproducto,rutaImagenProducto)
    {
     	$.post(feedback_dir + 'phpfbtw/saveOrderCommentsTwitterMessages.php',{message:message,rutaalproducto:rutaalproducto,rutaImagenProducto:rutaImagenProducto,redirect:feedback_dir}
     	,function(){
     		callSendToTwitter--;
     		 mandaAlTwitter(callSendToTwitter);
     	});
    }
    function mandaAlTwitter(callSendToTwitter)
    {
    	if((callSendToTwitter==0) && (sendToTwitter != 0))
    	{
    		var width  = 640;
			var height = 480;
    		var left = parseInt((screen.width / 2) - (width / 2));
    		var top = parseInt((screen.height / 2) - (height / 2));
	    	var windowFeatures = "width=" + width + ",height=" + height + ",menubar=yes,toolbar=yes,scrollbars=yes,resizable=yes,left=" + left + ",top=" + top + "screenX=" + left + ",screenY=" + top;
			window.open(feedback_dir + "phpfbtw/logintwitter.php","twpost",windowFeatures);
    	}
    }
    
});

	//mostrar listado de comentarios
	function viewFeedbackComments(page,allComments)
	{
		var filter = $('#lstOrderBy').val();
		var star = $('#txtStar').val();

   		if (page != undefined && star != undefined)
   		{   
   			var strAllComments = '';
   			
   			if(allComments)
   				strAllComments = '&allComments=' + true;
   				
        	$.ajax({
           		type: 'POST',
           		url: feedback_dir + 'shopfeedbacklist.php',
           		async: false,
           		cache: false,
           		dataType : 'html',
           		data: 'page=' + page + '&star=' + star + '&filter=' + filter + strAllComments,
           		beforeSend: function()
           		{
                	$("#shopfeedbacklist").empty().html('<center><img src="img/loader_big.gif" /></center>');
           		},
           		success: function(Data)
           		{
                	$("#shopfeedbacklist").empty().html(Data);  
                	
                	$("input[name^=radioListCommentGradeFeedbackDialog]").rating();
           		},
           		error: function(XMLHttpRequest, textStatus, errorThrown) {alert("TECHNICAL ERROR: unable to view rating \n\nDetails:\nError thrown: " + XMLHttpRequest + "\n" + 'Text status: ' + textStatus);}
       		}); 
       		$('#txtStar').val(star); 
       		$('#lstOrderBy').val(filter);      
   		}
	}