<?php
/*
* 2011 Judith Buetas Solanellas
*
* NOTICE OF LICENSE
*
* This source file is subject to the Academic Free License (AFL 3.0)
* that is bundled with this package in the file LICENSE.txt.
* It is also available through the world-wide-web at this URL:
* http://opensource.org/licenses/afl-3.0.php
* If you did not receive a copy of the license and are unable to
* obtain it through the world-wide-web, please send an email
* to license@prestashop.com so we can send you a copy immediately.
*
* DISCLAIMER
*
* Do not edit or add to this file if you wish to upgrade PrestaShop to newer
* versions in the future.
*
*  @author Judith Buetas Solanellas <jbuetass@uoc.edu>
*  @copyright  2011 Judith Buetas Solanellas
*  @date 26/12/2011
*  @version  Release: $Revision: 1.0 $
*  @license    http://opensource.org/licenses/afl-3.0.php  Academic Free License (AFL 3.0)
*/

require_once(dirname(__FILE__).'/../../config/config.inc.php');
require_once(dirname(__FILE__).'/../../init.php');

if(isset($_POST['action']))
{
    global $cookie;

    $action = Tools::getValue('action');
    
    switch ($action)
    {
	case 'saveFeedbackComment':
	    if (isset($_POST['txt_feedback_comment']) AND isset($_POST['rdo_feedback_comment_grade']))
	    { 
	   			require_once(dirname(__FILE__).'/ShopFeedbackSql.php');
              	$shopfeedbackSql = new shopfeedbackSql();
              
                $shopfeedbackSql->comment 	= Tools::getValue('txt_feedback_comment');
                $shopfeedbackSql->id_customer 	= (int)$cookie->id_customer;
                $shopfeedbackSql->id_guest 	= 0;
                $shopfeedbackSql->customer_name = ucwords($cookie->customer_firstname) . " " . ucwords($cookie->customer_lastname);
                $shopfeedbackSql->grade 	= Tools::getValue('rdo_feedback_comment_grade');
                $shopfeedbackSql->date_add 	= date('Y-m-d H:i:s');
                $shopfeedbackSql->validate 	= !Configuration::get('FEEDBACK_COMMENTS_MODERATE');
                
                //insertar nuevo comentario en la tabla product_comment
                $resultAdd = $shopfeedbackSql->add();
                
                if($resultAdd == true)
				{
                    $id_order = Tools::getValue('id_order');
                    
                    $shopfeedbackSql->id = (int)$id_order;
                    $shopfeedbackSql->send = 1;
                    $shopfeedbackSql->addhopFeedbackOrderCommentsEmails();
                    
                    require_once(dirname(__FILE__).'/shopfeedback.php');
                    $shopfeedback = new shopfeedback();
                    
                    $shopfeedback->sendOrderCommentsAdvice($id_order);
                    
                    print 'http://'.Configuration::get('PS_SHOP_DOMAIN').__PS_BASE_URI__;
                }
	    }	
	break;
        case 'saveProductComment':           
            if (isset($_POST['id_product']) AND isset($_POST['count_criterions']) AND isset($_POST['txt_title_product_comment']) AND isset($_POST['txt_content_product_comment']))
            {
                require_once(_PS_MODULE_DIR_.'productcomments/ProductComment.php');
               
                $productComment = new ProductComment();
                
                $count_criterions = Tools::getValue('count_criterions');
                
                $grade = 0;
                for($i=0; $i<$count_criterions; $i++)
                {
                    $aGradeValue[$i]        = Tools::getValue($i.'orderCommentGrade');
                    $aGradeCriterium[$i]    = Tools::getValue($i.'id_criterion');
                    
                    $grade += $aGradeValue[$i];
                }
                if (($count_criterions) > 0)
		    $productComment->grade = ($grade / ($count_criterions));
                
                $productComment->id_customer 	= (int)$cookie->id_customer;
                $productComment->id_guest       = 0;
                $productComment->customer_name  = ucwords($cookie->customer_firstname) . " " . ucwords($cookie->customer_lastname);               
                $productComment->id_product     = (int)Tools::getValue('id_product');		
		$productComment->title 		= Tools::getValue('txt_title_product_comment');
		$productComment->content 	= Tools::getValue('txt_content_product_comment');
		$productComment->validate 	= !Configuration::get('PRODUCT_COMMENTS_MODERATE');
		$productComment->date_add 	= date('Y-m-d H:i:s');
		
		//aadir comentario en la tabla productcomments
		$result_product_comment = $productComment->save();
                
                if($result_product_comment == true)
		{
                    require_once(_PS_MODULE_DIR_.'productcomments/ProductCommentCriterion.php');
                    
                    for($i=0; $i<$count_criterions; $i++)
                    {
                        $productCommentCriterion = new ProductCommentCriterion((int)$aGradeCriterium[$i]);
                        
                        //insertar nuevo comentario en la tabla product_comment_grade
                        if ($productCommentCriterion->id)
                            $result_product_comment_criterion = $productCommentCriterion->addGrade($productComment->id, $aGradeValue[$i]);
                    }
                }
            }
	break;
	default:
	    ;
    }
}